function A_BombThink(actor)
	actor.spritexscale = 3*FRACUNIT/2
	actor.spriteyscale = 3*FRACUNIT/2
	
	if actor.state == S_SBMB_EXPLODE1
		actor.cusval = actor.cusval - 1
		
		// Speed it up if the player is too close
		if P_LookForPlayers(actor, 128*FRACUNIT, true, false)
			actor.cusval = actor.cusval - 2
		end
		if P_LookForPlayers(actor, 384*FRACUNIT, true, false)
			actor.cusval = actor.cusval - 1
		end
		
		if actor.cusval < 0 // Failsafe
			actor.cusval = 0
		end
		
		if actor.cusval == 0
			for i = 0,12
				local explosion = P_SpawnMobjFromMobj(actor, 0, 0, actor.height, MT_SLZBOMBPARTICLE)
				P_Thrust(explosion, FixedAngle((i*30)*FRACUNIT), 8*FRACUNIT)
				P_SetObjectMomZ(explosion, 8*FRACUNIT, false)
			end
			P_SetMobjStateNF(actor, S_XPLD1)
		end
		return
	end
	
	local bombrotation = ((actor.x+actor.y+actor.floorz)/FRACUNIT + P_RandomRange(0,18)) % 7
	
	if P_LookForPlayers(actor, 512*FRACUNIT, true, false)
		P_NewChaseDir(actor)
		local spark = P_SpawnMobj(actor.x, actor.y, actor.z + 2*FRACUNIT, MT_SLZBOMBSPARK)
		P_SetScale(spark, actor.scale, true)
		spark.target = actor
		actor.cusval = 70
		P_SetMobjStateNF(actor, S_SBMB_EXPLODE1)
		return
	end
	
	if actor.reactiontime == 0 or P_Move(actor, 4) == false
		bombrotation = (actor.x/FRACUNIT + P_RandomRange(0,18)) % 7
		actor.reactiontime = 30
	end
	
	actor.angle = FixedAngle((bombrotation*45)*FRACUNIT)
	actor.movedir = bombrotation
	actor.reactiontime = actor.reactiontime - 1
		
    P_Move(actor, 4)
end

function A_BombSpark(actor)
	if (not actor.target or not actor.target.health)
		P_RemoveMobj(actor)
		return
	end
	actor.z = actor.target.z + 40*FRACUNIT + (actor.target.cusval / 8)*FRACUNIT
end

function A_UniUniInit(actor) // If you're having trouble with anything similar, you can take this code (no need for credit, it's just SRB2's code but modified to work in BLUA)
	local balllimit = 5 // Replacement for actor.info.damage
	local balltype = MT_UNIUNIBALL // Replacement for actor.info.painchance
	
	for i = 0,5
		local ball = P_SpawnMobj(actor.x, actor.y, actor.z, balltype)
		P_SetScale(ball, actor.scale, true)
		ball.target = actor
		ball.movedir = FixedAngle(FixedMul(FixedDiv(i<<FRACBITS, balllimit<<FRACBITS), 360<<FRACBITS))
		ball.threshold = ball.radius + actor.radius + FixedMul(ball.info.painchance, ball.scale)
	end
end

function A_UniUniBall(actor)
	actor.angle = actor.angle + ANGLE_11hh

	if (actor.movecount)
		if (P_AproxDistance(actor.momx, actor.momy) < FixedMul(actor.info.damage/2, actor.scale))
			P_ExplodeMissile(actor)
			return
		end
	end

	if (not actor.target or not actor.target.health)
		P_RemoveMobj(actor)
		return
	end

	local angle = actor.movedir + FixedAngle(actor.info.speed*(leveltime%360))
	local fa = angle
	
	local px = actor.target.x + FixedMul(cos(fa),actor.threshold)
	local py = actor.target.y + FixedMul(sin(fa),actor.threshold)
	local pz = actor.target.z + actor.target.height/2 - actor.height/2
	
	P_SetOrigin(actor, px, py, pz)
	//print(tostring(px/FRACUNIT) + ", " + tostring(py/FRACUNIT) + ", " + tostring(pz/FRACUNIT))
end